<?php
/*
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2003 Bharat Mediratta
 * Copyright (C) 2004 Jeremy Gilliat
 * Copyright (C) 2004 Ryan Kawailani Ozawa
 * Modified Jeremy Gilliat's stats.php hack (derived from albums.php) to
 * display linked thumbnails only (for use in SSI/PHP includes) sorted by:
 *    - number of views (clicks) - use include.php?type=views
 *    - upload date - use include.php?type=date
 *    - number of votes - use include.php?type=votes
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id$
 */
?>
<?php

// Control variables (multiple page display mooted).
$photocount = 5;
$maxphotos = 10;
// You can also comment out the $photocount line above, and add a variable to
// your URL: include.php?type=date&photocount=10 - but if you do this, you need
// to specify the photocount variable when include.php is called, or you'll get
// a divisible by zero error.

// Hack prevention.
if (!empty($HTTP_GET_VARS["GALLERY_BASEDIR"]) ||
		!empty($HTTP_POST_VARS["GALLERY_BASEDIR"]) ||
		!empty($HTTP_COOKIE_VARS["GALLERY_BASEDIR"])) {
	print _("Security violation") ."\n";
	exit;
}
?>
<?php if (!isset($GALLERY_BASEDIR)) {
    $GALLERY_BASEDIR = '';
}
require($GALLERY_BASEDIR . 'init.php'); ?>
<?php
$borderColor = $gallery->app->default["bordercolor"];
// I set this to a static number for small, 72-pixel thumbnails.
// To use the Gallery default, change this line to the following:
// $thumbSize = $gallery->app->default["thumb_size"];
$thumbSize = 72;
?>

<?php 
$navigator["fullWidth"] = 100;
$navigator["widthUnits"] = "%";
$albumDB = new AlbumDB();
$list = $albumDB->albumList;
$numAlbums = count($list);
$skip = array();
for ($i = 0; $i<$numAlbums; $i++) {
	$statsAlbum = $list[$i]; 
	if ($statsAlbum->versionOutOfDate()) {
		$skip[] = $statsAlbum;
		continue;
	}
	$uid = $gallery->user->getUid();
	if ($statsAlbum->canRead($uid) || $gallery->user->isAdmin()) {
		$numPhotos = $statsAlbum->numPhotos(1);
		for ($j = 1; $j <= $numPhotos; $j++) {
			if ( !isAlbum($statsAlbum, $j) )
			{
				$views = $statsAlbum->getItemClicks($j);
				$uploaddate = $statsAlbum->getUploadDate($j);
				$arrPhotos[] = array("albumName" => $statsAlbum->fields['name'],
                                	             "photoIndex" => $j,
                                        	     "votes" => $votes,
						     "views" => $views,
						     "uploaddate" => $uploaddate);
			}
		}
	}
}
if ( $type == "votes" )
{	
	usort($arrPhotos, "votesort"); 
}
else if ( $type == "views" )
{
        usort($arrPhotos, "viewsort");
}
else if ( $type == "date" )
{
        usort($arrPhotos, "datesort");
}
function votesort($a, $b) { 
        if ($a['votes'] == $b['votes']) { 
              return 0; 
        } 
        return ($a['votes'] > $b['votes']) ? -1 : 1; 
} 
function viewsort($a, $b) {
        if ($a['views'] == $b['views']) {
              return 0;
        }
        return ($a['views'] > $b['views']) ? -1 : 1;
}
function datesort($a, $b) {
        if ($a['uploaddate'] == $b['uploaddate']) {
              return 0;
        }
        return ($a['uploaddate'] > $b['uploaddate']) ? -1 : 1;
}
$uid = $gallery->user->getUid();
if ( !isset($page) )
{
	$page = 1;
}
if ( $maxphotos < 0 || $maxphotos > sizeof($arrPhotos))
{
	$maxphotos = sizeof($arrPhotos);
}
$startPhoto = ($page - 1) * $photocount;
// Use fuz factor to avoid rounding up when result is 0.5
$lastpage = round( ($maxphotos / $photocount) - 0.500001) + 1;
?>

<?php
for ($j = $startPhoto; $j < $maxphotos && $j < $startPhoto + $photocount; $j+=1) 
{
	$photoInfo = $arrPhotos[$j];
	for ( $i = 0; $i < $numAlbums; ++$i )
	{
		if ( !strcmp($photoInfo['albumName'], $list[$i]->fields['name']) )
		{
			$statsAlbum = $list[$i];
			break;
		}
	}

	if (isset($statsAlbum))
	{
		$photoIndex = $photoInfo['photoIndex'];
		$photoId = $statsAlbum->getPhotoId($photoIndex);
		if ($statsAlbum->canRead($uid) || $gallery->user->isAdmin())
		{
			if (!$statsAlbum->isHidden($photoIndex) || 
			     $statsAlbum->isOwner($uid) || 
			     $gallery->user->isAdmin())
			{
				$statsCaption = $statsAlbum->getCaption($photoIndex);
				$statsCaption .= $statsAlbum->getCaptionName($photoIndex);
				$statsUrl = makeAlbumUrl($statsAlbum->fields['name'], $photoId);
?>

<?php
      $gallery->html_wrap['imageTag'] =  $statsAlbum->getThumbnailTag($photoIndex, $thumbSize);
      $gallery->html_wrap['imageHref'] = $statsUrl;
      $gallery->html_wrap['frame'] = "none";
      includeHtmlWrap('inline_gallerythumb.frame');
?>
<?php
			}
		}
	}
}

function isVer143plus()
{
   global $gallery;
   return (int)$gallery->app->config_version >= 80; 
}

function isAlbum($album, $index)
{
   if ( isVer143plus())
      return $album->isAlbum($index);
   else
      return $album->isAlbumName($index); 
}

function getAlbumName($album, $index)
{
   if ( isVer143plus())
      return $album->getAlbumName($index);
   else
      return $album->isAlbumName($index);
}

?>

<?php
/*
 * To call these images from another page on your site, you can use either
 * PHP or SSI include calls.  In a PHP page, use the command:
 *
 * <?
 * include "http://www.yourdomain.com/gallery/include.php?type=xxxx";
 * ?>
 *
 * In a SHTML page, use the command:
 *
 * <!--#include virtual="relative/path/to/include.php?type=xxxx"-->
 *
 * Change 'xxxx' to your preferred sort type.  And remember, you can specify
 * for each include the number of images shown by commenting out the $photocount
 * variable above and adding it to your include URL.  For example:
 * <!--#include virtual="relative/path/to/include.php?type=date&photocount=10"-->
 */
?>
<?php

